commit 0d87092f8897fe6e0a86a566bf3c6a924db152c6
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Fri Jan 28 11:04:06 2022

    Fix wrong operator for universal_integer operands in instance
    
    This is a regression present on mainline and 11 branch: the transformation
    applied during expansion by Narrow_Large_Operation would incorrectly perform
    name resolution for the operator again.
    
    gcc/ada/
            PR ada/104258
            * exp_ch4.adb (Narrow_Large_Operation): Also copy the entity, if
            any, when rewriting the operator node.
    
    gcc/testsuite/
            * gnat.dg/generic_comp.adb: New test.

diff --git a/gcc/ada/exp_ch4.adb b/gcc/ada/exp_ch4.adb
index 04bd1fe0dba..44370786a3d 100644
--- a/gcc/ada/exp_ch4.adb
+++ b/gcc/ada/exp_ch4.adb
@@ -14304,9 +14304,13 @@ package body Exp_Ch4 is
          return;
       end if;
 
-      --  Finally, rewrite the operation in the narrower type
+      --  Finally, rewrite the operation in the narrower type, but make sure
+      --  not to perform name resolution for the operator again.
 
       Nop := New_Op_Node (Kind, Sloc (N));
+      if Nkind (N) in N_Has_Entity then
+         Set_Entity (Nop, Entity (N));
+      end if;
 
       if Binary then
          Set_Left_Opnd (Nop, Convert_To (Ntyp, L));
diff --git a/gcc/testsuite/gnat.dg/generic_comp.adb b/gcc/testsuite/gnat.dg/generic_comp.adb
new file mode 100644
index 00000000000..8c7b16f8aae
--- /dev/null
+++ b/gcc/testsuite/gnat.dg/generic_comp.adb
@@ -0,0 +1,39 @@
+-- { dg-do run }
+
+procedure Generic_Comp is
+
+   generic
+      type Element_Type is private;
+      type Index_Type is (<>);
+      type Array_Type is array (Index_Type range <>) of Element_Type;
+      with function ">" (Left, Right : Element_Type) return Boolean is <>;
+   procedure Gen (Data: in out Array_Type);
+
+   procedure Gen (Data: in out Array_Type) is
+   begin
+      if not (Data'Length > 1)
+        or else not (Integer'(Data'Length) > 1)
+        or else not Standard.">" (Data'Length, 1)
+        or else not Standard.">" (Integer'(Data'Length), 1)
+      then
+         raise Program_Error;
+      end if;
+   end;
+
+   type My_Array is array (Positive range <>) of Integer;
+
+   function Less_Than (L, R : Integer) return Boolean is
+   begin
+      return L < R;
+   end;
+
+   procedure Chk_Down is new Gen (Element_Type => Integer,
+                                  Index_Type   => Positive,
+                                  Array_Type   => My_Array,
+                                  ">"          => Less_Than);
+
+   Data : My_Array (1 .. 2);
+
+begin
+   Chk_Down (Data);
+end;

